/**********************************************************
 ** gPND maker v.0.1 BETA 1                              **
 ** By: Steven Arnow (steven@slaeshjag.org)              **
 ** License: LGPL v.2                                    **
 **********************************************************/


#ifndef _GPND_H_
#define	_GPND_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>

#define	GPND_MESSAGE_CHILD_WINDOW	0x1

#define	GPND_MAIN_GENISOIMAGE		0x100
#define	GPND_MAIN_GENSQUASHFS		0x200
#define	GPND_MAIN_GENCRAMFS		0x400

#define	GPND_APP_THEREISNEXTAPP		0x1
#define	GPND_APP_APPISVALID		0x2

#define	GPND_MAIN_IMAGEFS		0xFF00

typedef struct {
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *addbox;
	GtkWidget *toolbox;
	GtkWidget *mainbox;
	GtkWidget *applist;
	GtkWidget *appscroll;
	GtkWidget *dget;

	GtkWidget *addApp;
	GtkWidget *renApp;
	GtkWidget *delApp;
	GtkWidget *appName;
	
	GtkWidget *new;
	GtkWidget *seldir;
	GtkWidget *appinfo;
	GtkWidget *apprun;
	GtkWidget *appndesc;
	GtkWidget *cat;
	GtkWidget *selprevpics;
	GtkWidget *savepnd;
} GPND_GTK;

typedef struct {
	GtkWidget *window;
	GtkWidget *table;
	
	GtkWidget *okbtn;
	GtkWidget *canbtn;
	
	GtkWidget *authorl;
	GtkWidget *httpl;
	GtkWidget *maill;
	GtkWidget *appnamel;
	GtkWidget *descl;
	GtkWidget *iconl;
	GtkWidget *catl;
	GtkWidget *subcatl;
	
	GtkWidget *authore;
	GtkWidget *httpe;
	GtkWidget *maile;
	GtkWidget *appnamee;
	GtkWidget *desce;
	GtkWidget *icone;
	GtkWidget *subcate;
	
	GtkWidget *cat;
} GPND_APPINFO;

typedef struct {
	GtkWidget *window;
	GtkWidget *table;
	
	GtkWidget *uidl;
	GtkWidget *appdatal;
	GtkWidget *startdirl;
	GtkWidget *x11l;
	GtkWidget *execfilel;
	GtkWidget *argsl;
	GtkWidget *cpufreql;
	GtkWidget *allowMultitaskingl;
	GtkWidget *standalonel;

	GtkWidget *uide;
	GtkWidget *appdatae;
	GtkWidget *startdire;
	GtkWidget *x11e;
	GtkWidget *execfilee;
	GtkWidget *argse;
	GtkWidget *cpufreqe;
	GtkWidget *allowMultitaskinge;
	GtkWidget *standalonee;

	GtkWidget *okbtn;
	GtkWidget *canbtn;
} GPND_RUNTIME;


typedef struct {
	GtkWidget *window;
	GtkWidget *table;
	
	GtkWidget *authorl;
	GtkWidget *httpl;
	GtkWidget *maill;
	GtkWidget *versionl;
	GtkWidget *iconl;
	GtkWidget *descl;

	GtkWidget *authore;
	GtkWidget *httpe;
	GtkWidget *maile;
	GtkWidget *versione;
	GtkWidget *icone;
	GtkWidget *desce;

	GtkWidget *okbtn;
	GtkWidget *canbtn;
} GPND_GENERAL;


typedef struct {
	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *vbox;
	GtkWidget *btnbox;
	GtkWidget *descscroll;
	GtkWidget *listscroll;
	
	GtkWidget *langl;
	GtkWidget *namel;
	GtkWidget *descl;

	GtkWidget *lange;
	GtkWidget *namee;
	GtkWidget *desce;

	GtkWidget *list;

	GtkWidget *addbtn;
	GtkWidget *delbtn;
	GtkWidget *modbtn;
	GtkWidget *okbtn;
} GPND_NDESC;

typedef struct {
	GtkWidget *window;
	GtkWidget *table;
	
	GtkWidget *savetol;
	GtkWidget *fsl;

	GtkWidget *savetoe;
	GtkWidget *fse;

	GtkWidget *browsebtn;
	GtkWidget *okbtn;
	GtkWidget *canbtn;
} GPND_SAVEPND;

typedef struct {
	GtkWidget *window;
	GtkWidget *table;

	GtkWidget *catl;
	GtkWidget *subl;

	GtkWidget *cate;
	GtkWidget *sube;

	GtkWidget *list;
	GtkWidget *listscroll;

	GtkWidget *addbtn;
	GtkWidget *delbtn;
	GtkWidget *modbtn;
	GtkWidget *okbtn;
} GPND_CAT;


typedef struct {
	int cat;
	char *subcat;
	int flags;
} GPND_CATEGORY_STRUCT;


typedef struct {
	char *lang;
	char *name;
	char *desc;
	int flags;
} GPND_NAMEDESC_STRUCT;


typedef struct {
	char *author;
	char *http;
	char *mail;
	char *appname;
	char *desc;
	char *icon;
	char *version;

	char *uid;
	char *appdata;
	char *startdir;
	char *execfile;
	char *args;

	GPND_CATEGORY_STRUCT *cat;
	GPND_NAMEDESC_STRUCT *ndesc;
	
	int cpufreq;
	int x11;
	int allowMultitasking;
	int standalone;
	int activeLang;
	int noofCat;

	int flags;
} GPND_APP;
	

typedef struct {
	unsigned int flags;
	char *dirname;

	int activeApp;
	int localelen;
	char **locales;
	
	int noofApps;

	char *target;
	int childKillID;
	
	GPND_GTK gtkstruct;
	GPND_GENERAL gtkgeneral;
	GPND_RUNTIME gtkruntime;
	GPND_NDESC gtkndesc;
	GPND_SAVEPND gtksavepnd;
	GPND_CAT gtkcat;
	GPND_APP *app;
	
	GtkWidget *currentWindow;
} GPND_MAIN;

#endif
